// Ajax Star Rating Script - https://coursesweb.net/

/*
Here it can be set what rating stars system to use:
  Five stars, with five numbers to rate (1, 2, 3, 4, 5). - Default
  Five stars, with 10 numbers to rate (1, 2, .., 10).    var rt_style ='5/2';
  Seven stars, with 7 numbers to rate (1, 2, .., 7).     var rt_style =7;
  Ten stars, with 10 numbers to rate (1, 2, .., 10).     var rt_style =10;
*/
var rt_style =5;

class rtStars {
  //receives rating style type and object name of the class
  constructor(rt_style, ob_name){
    this.ob = ob_name;
    this.rt_style = rt_style;
    this.sratings =[]; // store the items with rating
    this.ar_elm =[]; // store the items that will be send to rtgAjax()
    this.item_rtg =''; // store the rating of rated item
    this.rt_ver_style ={
      '5':{n:5, w:22, st:''},
      '5/2':{n:10, w:11, st:'.srtgs{width:170px;}.srtgs .star_n{max-width:168px;}.totalrate i{padding-right:8px;}.srtgs .d_rtg span {width:11px;}.srtgs em{bottom:1px;left:125px;margin:0;position:absolute;text-align:center;}'},
      '7':{n:7, w:22, st:'.srtgs{width:155px;}.srtgs .star_n{max-width:153px;}.srtgs .stars, .srtgs .d_rtg, .srtgs .totalrate{width:154px;}'},
      '10':{n:10, w:22, st:'.srtgs{width:225px;}.srtgs .star_n{max-width:225px;}.srtgs .stars, .srtgs .d_rtg, .srtgs .totalrate{width:221px;}'}
    }; //style for each type of rating (5, '5/2', 7, 10)

    //add version style
    if(this.rt_ver_style[this.rt_style].st !=''){
      document.querySelector('head').insertAdjacentHTML('beforeend', '<style>'+this.rt_ver_style[this.rt_style].st+'</style>');
    }
    this.getRtgsElm();
  }

  // gets all DIVs, then add in $ar_elm the DIVs with class="srtgs", and ID which begins with "rt_", and sends to rtgAjax()
  getRtgsElm(){
    let obj_div = document.querySelectorAll('.srtgs');
    let i_elm =0; // Index for elements aded in ar_elm

    for(var i=0; i<obj_div.length; i++) {
      // if contains class and id
      if(obj_div[i].id) {
        let val_id = obj_div[i].id;

        // if id begins with "rt_"
        if(val_id.indexOf('rt_')==0) {
          this.sratings[val_id] = obj_div[i];
          this.ar_elm[i_elm] = val_id;
          i_elm++;
        }
      }
    }
    // If there are elements with rates, send them to rtgAjax()
    if(this.ar_elm.length>0) this.rtgAjax(this.ar_elm, '');
  }

  // shows the stars when the user is voting
  rateStars(spn){
    let i_sp = spn.id.replace('d_', '')*1; // gets the number from id
    if(spn.parentNode.parentNode) {
      let star_sp = spn.parentNode.parentNode.childNodes[0];		// gets the element with stars

    if(this.item_rtg =='' && spn.parentNode.parentNode.parentNode) this.item_rtg = spn.parentNode.parentNode.parentNode.innerHTML; // store the rating of rated item

      if(spn.parentNode.parentNode.parentNode) spn.parentNode.parentNode.parentNode.childNodes[0].innerHTML ='<i>Rate:</i><span>'+(i_sp+1)+'</span>'; // shows the choosed rating

      // Modify the length and background of the zone with vizible stars
      star_sp.style.width = ((i_sp+1)*this.rt_ver_style[this.rt_style].w)+'px';
      star_sp.style.background ='url("ratingfiles/star2.png")';
    }
  }

  // add the ratting data to element in page
  addRtgData(elm, totalrate, nrrates, renot){
    let avgrating = (nrrates>0) ? totalrate/nrrates : 0; // sets average rating and length of area with stars

    // convert in string, if has more that 3 characters, convert it in number with decimals
    avgrating = avgrating+'';
    if(avgrating.length>3) {
      avgrating *= 1; avgrating = avgrating.toFixed(1);
    }
    let star_n = this.rt_ver_style[this.rt_style].w*avgrating;

    // HTML code for rating, add 10 SPAN tags, each one for a half of star, only if renot=0
    let d_rtg ='';
    if(renot==0) {
      for(var i=0; i<this.rt_ver_style[this.rt_style].n; i++) {
        d_rtg += '<span id="d_'+i+'" onmouseenter="'+this.ob+'.rateStars(this)" onclick="'+this.ob+'.rateIt(this)">&nbsp;</span>';
      }
      d_rtg = '<div class="d_rtg" onmouseleave="'+this.ob+'.reRating(event, \''+elm+'\', \''+totalrate+'\', \''+nrrates+'\')">'+d_rtg+'</div>';
    }

    // Create and add HTML with stars, and rating data
    let htmlrtg = '<div class="totalrate"><i>Rating:</i>'+avgrating+'</div><div class="stars"><div class="star_n" style="width:'+star_n+'px;">&nbsp;</div>'+d_rtg+'</div><em>'+nrrates+' votes</em>'
    if(this.sratings[elm]) this.sratings[elm].innerHTML = htmlrtg;
  }

  // Sends data to rtgAjax(), that will be send to PHP to register the vote
  rateIt(spn){
    let elm =[];
    elm[0] = spn.parentNode.parentNode.parentNode.id; // gets the item-name that will be rated
    let ratev = spn.id.replace('d_', '')*1+1; // gets the rating value from id

    spn.parentNode.parentNode.parentNode.innerHTML ='<i><b>Thanks for rating</b></i>';
    this.rtgAjax(elm, ratev);
  }

  // Function called by onmouseout to shows initial rating
  reRating(evt, elm, totalrate, nrrates){
    this.item_rtg ='';    // empty item_rtg to can store other data

     // if event from element with class="d_rtg', calls addRtgData()
     if(evt.target.className=='d_rtg') this.addRtgData(elm, totalrate, nrrates, 0);
  }

  /*** Ajax ***/

  // sends data to PHP and receives the response
  rtgAjax(elm, ratev){
    let obajx =  (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP'); // XMLHttpRequest object

    // define data to be send via POST to PHP (Array with name=value pairs)
    let datasend =[];
    for(var i=0; i<elm.length; i++) datasend[i] = 'elm[]='+elm[i];
    // joins the array items into a string, separated by '&'
    datasend = datasend.join('&')+'&rate='+ratev;

    obajx.open('post', '/ratingfiles/ratings.php', true); // crate the request

    obajx.setRequestHeader('Content-type', 'application/x-www-form-urlencoded'); // header for POST
    obajx.send(datasend); // make the ajax request, poassing the data

    // checks and receives the response
    obajx.onreadystatechange =()=>{
      if (obajx.readyState == 4) {
        // receives a JSON with one or more item:['totalrate', 'nrrates', renot]
        let jsonitems = JSON.parse(obajx.responseText);
        let renot;

        // if jsonitems is defined variable
        if(jsonitems) {
          // parse the jsonitems object
          for(var rtgitem in jsonitems){
            let data_rt = this.sratings[rtgitem].getAttribute('data-rt');
            renot = (data_rt && data_rt=='novote') ?1 :jsonitems[rtgitem][2]; // determine if the user can rate or not

            // if renot=3 displaies alert that already voted, else, continue with the rating reactualization
             if(renot == 3) {
              alert('You already voted \n You can rate again tomorrow');
              window.location.reload(true);		// Reload the page
            }
            else this.addRtgData(rtgitem, jsonitems[rtgitem][0], jsonitems[rtgitem][1], renot);	// calls function that shows rating
          }
        }

        // if renot is undefined or 2 (set to 1 item rated per day), after vote, removes the element for rate from each elm (removing childNode 'd_rtg')
        if(ratev !='' && (renot == undefined || renot == 2)) {
          if(renot == undefined) document.getElementById(elm[0]).innerHTML = this.item_rtg;
          
          for(var i=0; i<this.ar_elm.length; i++) {
          if(this.sratings[this.ar_elm[i]].childNodes[1].childNodes[1])
            this.sratings[this.ar_elm[i]].childNodes[1].removeChild(this.sratings[this.ar_elm[i]].childNodes[1].childNodes[1]);
          }
        }
      }
    }
  }
}

var rt_Stars ={};
setTimeout(()=>{ rt_Stars = new rtStars(rt_style, 'rt_Stars');}, 555); // create object of rtStars class after a specified time